#ifndef _DEBUGGER_H_
#define _DEBUGGER_H_

#include "win32/MDIFrame.h"
#include "ELFView.h"
#include "DisAsmWnd.h"
#include "RegViewWnd.h"
#include "FunctionsView.h"
#include "MemoryViewMIPSWnd.h"
#include "Log.h"
#include "Settings.h"
#include "SlotHandler.h"

class CDebugger : public Framework::CMDIFrame
{
public:
									CDebugger();
									~CDebugger();
	HACCEL							GetAccelerators();

protected:
	long							OnCommand(unsigned short, unsigned short, HWND);
	long							OnSysCommand(unsigned int, LPARAM);

private:
	void							UpdateLoggingMenu();
	void							LoadSettings();
	void							SaveSettings();
	void							SerializeWindowGeometry(CWindow*, int*, int*, int*, int*, bool*);
	void							UnserializeWindowGeometry(CWindow*, int, int, int, int, bool);
	void							CreateAccelerators();
	void							DestroyAccelerators();
	void							Resume();
	void							StepCPU1();

	//Event handlers
	void							OnFunctionViewFunctionDblClick(uint32);
	void							OnFunctionViewFunctionsStateChange(int);
	void							OnExecutableChange(int);
	void							OnExecutableUnloading(int);

	Framework::CSlotHandler<int>*	m_pOnExecutableChangeHandler;
	Framework::CSlotHandler<int>*	m_pOnExecutableUnloadingHandler;

	HACCEL							m_nAccTable;
	CELFView*						m_pELFView;
	CFunctionsView*					m_pFunctionsView;
	CLog*							m_pLog;
	CDisAsmWnd*						m_pDisAsmWnd;
	CRegViewWnd*					m_pRegViewWnd;
	CMemoryViewMIPSWnd*				m_pMemoryViewWnd;
	CSettings*						m_pSettings;
};

#endif