#ifndef _MIPSANALYSIS_H_
#define _MIPSANALYSIS_H_

#include "Types.h"
#include "List.h"
#include "RangeList16.h"

struct MIPSSUBROUTINE
{
	uint32			nStart;
	uint32			nEnd;
};

class CMIPS;

typedef Framework::CList<MIPSSUBROUTINE> CSubList;
typedef Framework::CRangeList16<MIPSSUBROUTINE, 0x1FFFFFFF, 3> CArgh;

class CMIPSAnalysis
{
public:
										CMIPSAnalysis(CMIPS*);
										~CMIPSAnalysis();
	void								Analyse(uint32, uint32);
	MIPSSUBROUTINE*						FindSubroutine(uint32);
	void								Clear();
private:
	void								InsertSubroutine(uint32, uint32);
//	Framework::CList<MIPSSUBROUTINE>	m_Subroutine;
	CArgh								m_Hello;	
	CSubList							m_Subroutine;
	CSubList*							m_Hashed;
	CMIPS*								m_pCtx;
};

#endif
