#ifndef _REGVIEWFPU_H_
#define _REGVIEWFPU_H_

#include "CustomDrawn.h"
#include "MIPS.h"
#include "SlotHandler.h"

class CRegViewFPU : public CCustomDrawn
{
public:
									CRegViewFPU(HWND, RECT*, CMIPS*);
									~CRegViewFPU();

	enum VIEWMODE
	{
		VIEWMODE_WORD   = 0,
		VIEWMODE_LONG   = 1,
		VIEWMODE_SINGLE = 2,
		VIEWMODE_DOUBLE = 3,
		VIEWMODE_MAX,
	};

protected:
	void							Paint(HDC);
	long							OnRightButtonUp(unsigned int, unsigned int);
	long							OnCommand(unsigned short, unsigned short, HWND);

private:
	void							RenderWord(HDC);
	void							RenderSingle(HDC);
	void							RenderFCSR(HDC, unsigned int*);

	HFONT							GetFont();
	void							OnMachineStateChange(int);
	void							OnRunningStateChange(int);

	VIEWMODE						m_nViewMode;
	CMIPS*							m_pCtx;
	Framework::CSlotHandler<int>*	m_pOnMachineStateChangeHandler;
	Framework::CSlotHandler<int>*	m_pOnRunningStateChangeHandler;
};

#endif
